<%@ page import="com.xerox.docushare.*" %>
<%@ page import="com.xerox.docushare.routing.*" %>
<%@ page import="com.xerox.docushare.object.*" %>
<%@ page import="com.xerox.docushare.property.*" %>
<%@ page import="com.xerox.docushare.workflow.*" %>
<%@ page import="java.net.URLEncoder" %>
<%@ page import="com.xerox.docushare.amber.util.GenericUtil" %>
<%@ page import="com.xerox.docushare.amber.util.MessageDB" %>
<%@ page import="java.text.SimpleDateFormat" %>
<%@ page import="com.xerox.docushare.amber.util.AmberUtility" %>

<jsp:useBean id="dsrouting" scope="session" class="com.xerox.docushare.routing.DSRouting" />
<% dsrouting.setDSSession(request); 
String keySuffix = dsrouting.getDateKeySuffix(); //AR8506+: after dsrouting.setDSSession(request)
request.setCharacterEncoding(dsrouting.getCharEncoding());
response.setContentType(dsrouting.getContentType());
String contextPath = request.getContextPath();

    DSSession dsSession = (DSSession)request.getAttribute("DSSession");
    java.util.Locale locale = dsSession.getLocale();
    DSUser dsUser = (DSUser)dsSession.getLoginPrincipal();
    String user = dsUser.toString();

    DSDocument dsDocument = null;
    DSVersion dsVersion = null;
    String document = request.getParameter("document");
    String reroutedFromReportURLStr = null;
    String reroutedSubject = null;
    if (document != null) {
        try {
            DSObject dsObj = (DSObject)dsSession.getObject(new DSHandle(document));
            if (dsObj != null) {
                if (dsObj instanceof DSDocument) {
                    dsDocument = (DSDocument)dsObj;
                    dsVersion = dsDocument.getPreferredVersion((DSSelectSet)null);
                } else if (dsObj instanceof DSVersion) {
                    dsVersion = (DSVersion)dsObj;
                    dsDocument = dsVersion.getDocument((DSSelectSet)null);
                }
            }
        } catch (Exception ex) {
            // can't determine parent if error acessing objects
            out.println("error in getObject(): " + ex);
        }
    }
    if (document == null) {
%>
<h3>
<%= MessageDB.get("routing_error_no_doc_specified", locale) %>
</h3>
<%
    } else if (dsDocument == null) {
%>
<h3>
<%= MessageDB.get("routing_error_no_document", new Object[]{ document }, locale) %>
</h3>
<%
    } else {
        DSUser owner = (DSUser)dsDocument.getOwner(DSSelectSet.NO_PROPERTIES);
        String ownerStr = GenericUtil.getFullName(owner, dsSession);
        DSUser modifiedBy = (DSUser)dsDocument.getModifiedBy(DSSelectSet.NO_PROPERTIES);
        String modifiedByStr = "";
        if (modifiedBy != null) {
            modifiedByStr = GenericUtil.getFullName(modifiedBy, dsSession);
        }
        String summary = dsDocument.getSummary(); //AR10795: dsVersion -> dsDocument
        if (summary == null) {
            summary = "";
        }
        String description = dsDocument.getDescription(); //AR10795: dsVersion -> dsDocument
        if (description == null) {
            description = "";
        }
        String keywords = dsDocument.getKeywords(); //AR10795: dsVersion -> dsDocument
        if (keywords == null) {
            keywords = "";
        }
        String revisionComments = dsVersion.getRevisionComments();
        if (revisionComments == null) {
            revisionComments = "";
        }
        String abstr = dsVersion.getAbstract();
        if ((abstr == null || abstr.trim().length()==0) && dsDocument.isDraft())
            abstr = dsDocument.getAbstract(); //AR18298+
        if (abstr == null) {
            abstr = "";
        }
        String author = dsDocument.getAuthor();
        if (author == null) {
            author = "";
        }
%>

    <table class="propstable">
    <tr>
        <td><label><a href="javascript:openHelpTextWindow('<%= contextPath %>/dsweb/PropHelp/title')" 
         target="_parent"><%= MessageDB.get("title_label", locale) %>:</a></label></td>
        <td><%= AmberUtility.xss_safe_value(dsVersion.getTitle()) %></td>
    </tr>

    <tr>
        <td><label><a href="javascript:openHelpTextWindow('<%= contextPath %>/dsweb/PropHelp/summary')"
         target="_parent"><%= MessageDB.get("summary_label", locale) %>:</a></label></td>
        <td><%= AmberUtility.xss_safe_value(summary) %></td>
    </tr>

    <tr>
        <td><label><a href="javascript:openHelpTextWindow('<%= contextPath %>/dsweb/PropHelp/description')"
         target="_parent"><%= MessageDB.get("description_label", locale) %>:</a></label></td>
        <td><%= AmberUtility.xss_safe_value(description) %></td>
    </tr>

    <tr>
        <td><label><a href="javascript:openHelpTextWindow('<%= contextPath %>/dsweb/PropHelp/keywords')"
         target="_parent"><%= MessageDB.get("keywords_label", locale) %>:</a></label></td>
        <td><%= AmberUtility.xss_safe_value(keywords) %></td>
    </tr>

    <tr>
        <td><label><a href="javascript:openHelpTextWindow('<%= contextPath %>/dsweb/PropHelp/handle')"
         target="_parent"><%= MessageDB.get("handle_label", locale) %>:</a></label></td>
        <td><%= dsVersion.getHandle().toExternalForm() %></td>
    </tr>

    <tr>
        <td><label><a href="javascript:openHelpTextWindow('<%= contextPath %>/dsweb/PropHelp/owner')" 
         target="_parent"><%= MessageDB.get("owner_label", locale) %>:</a></label></td>
        <td><a href='<%= contextPath %>/dsweb/Services/<%= dsDocument.getOwner() %>'
         target='_new'><%= ownerStr %></a></td>
    </tr>

    <tr>
        <td><label><a href="javascript:openHelpTextWindow('<%= contextPath %>/dsweb/PropHelp/Version.revision_comments')" 
          target="_parent"><%= MessageDB.get("routing_version_comments", locale) %>:</a></label></td>
        <td><%= AmberUtility.xss_safe_value(revisionComments) %></td>
    </tr>

    <tr>
        <td><label><a href="javascript:openHelpTextWindow('<%= contextPath %>/dsweb/PropHelp/create_date')" 
         target="_parent"><%= MessageDB.get("create_date_label", locale) %>:</a></label></td>
        <td><%= new SimpleDateFormat(MessageDB.get("date_time_full"+keySuffix, locale), locale).format(dsDocument.getCreateDate()) %></td>
    </tr>

    <tr>
        <td><label><a href="javascript:openHelpTextWindow('<%= contextPath %>/dsweb/PropHelp/modified_date')" 
         target="_parent"><%= MessageDB.get("modified_date_label", locale) %>:</a></label></td>
        <td><%= new SimpleDateFormat(MessageDB.get("date_time_full"+keySuffix, locale), locale).format(dsDocument.getModifiedDate()) %></td>
    </tr>

    <tr>
        <td><label><a href="javascript:openHelpTextWindow('<%= contextPath %>/dsweb/PropHelp/modified_by')" 
         target="_parent"><%= MessageDB.get("modified_by_label", locale) %>:</a></label></td>
        <td><a href='<%= contextPath %>/dsweb/Services/<%= dsDocument.getModifiedBy(DSSelectSet.NO_PROPERTIES) %>'
         target='_new'><%= AmberUtility.xss_safe_value(modifiedByStr) %></a></td>
    </tr>

    <tr>
        <td><label><a href="javascript:openHelpTextWindow('<%= contextPath %>/dsweb/PropHelp/Document.author')" 
         target="_parent"><%= MessageDB.get("Author", locale) %>:</a></label></td>
        <td><%= AmberUtility.xss_safe_value(author) %></td>
    </tr>

    <tr>
        <td><label><a href="javascript:openHelpTextWindow('<%= contextPath %>/dsweb/PropHelp/content_type.File')" 
         target="_parent"><%= MessageDB.get("content_type.File_label", locale) %>:</a></label></td>
        <td><%= dsDocument.getContentType() %></td>
    </tr>

    <tr>
        <td><label><a href="javascript:openHelpTextWindow('<%= contextPath %>/dsweb/PropHelp/document_filename')" 
         target="_parent"><%= MessageDB.get("document_filename_label", locale) %>:</a></label></td>
        <td><%= AmberUtility.xss_safe_value(dsVersion.getPreferredRendition((DSSelectSet)null).getContentElements()[0].getPreferredFileName()) %></td>
    </tr>

    <tr>
        <td width="100"><label><a href="javascript:openHelpTextWindow('<%= contextPath %>/dsweb/PropHelp/Version.abstract')" 
         target="_parent"><%= MessageDB.get("routing_abstract", locale) %>:</a></label></td>
        <td><%= AmberUtility.xss_safe_value(abstr) %></td>
    </tr>
    
    <tr>
        <td><label><a href="javascript:openHelpTextWindow('<%= contextPath %>/dsweb/PropHelp/Document.size')" 
         target="_parent"><%= MessageDB.get("size", locale) %>:</a></label></td>
        <td><%= dsVersion.getPreferredRendition((DSSelectSet)null).getSize() %></td>
    </tr>
    
<%if (reroutedFromReportURLStr != null) {%>
    <tr>
        <td><label><a href="javascript:openHelpTextWindow('<%= contextPath %>/dsweb/PropHelp/rerouted_from')" 
         target="_parent"><%= MessageDB.get("rerouted_from_label", locale) %>:</a></label></td>
        <td><a href='javascript:openTaskWindow("<%= reroutedFromReportURLStr %>")'><%= reroutedSubject %></a></td>
    </tr>
<%}%>    
    </table>
<%}%> 
