<!--

Copyright (C) 2004 Fuji Xerox, Co., Ltd.. All Rights Reserved.
Copyright (C) 2004 Xerox Corporation. All Rights Reserved.

Version: $Id: tasks_assigned_by_me.jsp 93076 2015-12-03 08:10:45Z bchan $
-->

<!--
This page displays a list of routing tasks assigned by the current user
and allows the user to select and review tasks.  Tasks are removed from this
list from the individual task GUIs.
-->

<%@ page import="com.xerox.docushare.*" %>
<%@ page import="com.xerox.docushare.object.*" %>

<%@ page import="com.xerox.docushare.routing.*" %>
<%@ page import="com.xerox.docushare.workflow.*" %>
<%@ page import="com.xerox.docushare.amber.util.MessageDB" %>

<%@ page import="java.net.URLEncoder" %>
<%@ page import="java.util.*" %>
<%@ page import="java.text.SimpleDateFormat" %>

<%@ page import="com.xerox.docushare.amber.util.AmberUtility" %>

<jsp:useBean id="dsrouting" scope="session" class="com.xerox.docushare.routing.DSRouting" />
<jsp:useBean id="indexUtilBean" scope="request" class="com.xerox.docushare.routing.IndexRangeUtilBean" >
  <jsp:setProperty name="indexUtilBean" property="*"/>
</jsp:useBean>

<%
    dsrouting.setDSSession(request); 
    String keySuffix = dsrouting.getDateKeySuffix(); //AR8506+: after dsrouting.setDSSession(request)
    request.setCharacterEncoding(dsrouting.getCharEncoding());
    response.setContentType(dsrouting.getContentType());

    DSSession dsSession = (DSSession)request.getAttribute("DSSession");
    Locale locale = dsSession.getLocale();
    DSUser dsUser = (DSUser)dsSession.getLoginPrincipal();
    String user = dsUser.toString();

    ArrayList myBeans = null;
    String[] asked = new String[] {TaskBean.SUBJECT, TaskBean.STATUS, TaskBean.TASKBYMEDATE, TaskBean.ACTION, TaskBean.DUEDATE, TaskBean.TASKID};
    String buttonLabelPrevious  = MessageDB.get("route_selector_button_previous", locale);
    String buttonLabelNext      = MessageDB.get("route_selector_button_next", locale);
    String buttonLabelShowAll   = MessageDB.get("showAll", locale);
    String uiNextPage      = MessageDB.get("nextPage", locale);
    String uiPreviousPage  = MessageDB.get("previousPage", locale);
    String uiBlankImage    = MessageDB.get("blank_image", locale);
    String uiTaskIcon    = MessageDB.get("task_icon", locale);

    int totalTaskCount = dsrouting.getTaskBeanForOwnerCount(user); // ForOwner means TaskByMe

    // configurable
    indexUtilBean.setRangeMin("1");
    indexUtilBean.setRangeMax(""+totalTaskCount);
    int initialStart = 1, initialEnd = 10;

    int reqStartInt = initialStart;
    int reqEndInt = initialEnd;
    int pageSize = initialEnd - initialStart + 1;

    int pageCount = totalTaskCount/reqEndInt + ((totalTaskCount%reqEndInt==0) ? 0 : 1);
    int pageNumber = 1;

    // use the Bean value only if self-submitted, i.e. any of the following UI was activated    
    String direction = request.getParameter("pageDirection");
    String menuName = request.getParameter("pageRangeMenu");
    //System.out.println("pageDirection " + direction);
    if( direction != null && direction.trim().length()!=0 )
    {
        if(direction.equals("next") || direction.equals("previous"))
        {
            int oldPageNumberInt = Integer.parseInt(indexUtilBean.getPageRangeMenu());
            if(direction.equals("next"))
                pageNumber = oldPageNumberInt + 1;
            else
                pageNumber = oldPageNumberInt - 1;
            indexUtilBean.setPageRangeMenu(""+pageNumber);
            //reqStartInt = (pageNumber - 1) * pageSize + 1;
            //reqEndInt = pageNumber * pageSize ;
		%>
			<script language="javascript">
			<!--
				updateNextPrevious(<%=pageNumber%>);
			//-->
			</script>
		<%
        }
    }
    else if(menuName != null)
    {
        if(menuName.equals(buttonLabelShowAll))
        {
            reqStartInt = initialStart;
            reqEndInt = totalTaskCount;
            pageNumber = 1;
        }
        else
        {
            int pageNumberWanted = Integer.parseInt(menuName);
	    	if(pageNumberWanted > pageCount)
	    	{
				%>
					<script language="javascript">
					<!--
						updateMyTasksAssignedByMeMinusOne(<%=pageNumberWanted%>);
					//-->
					</script>
				<%
	    	}
            reqStartInt = (pageNumberWanted - 1) * pageSize + 1;
            reqEndInt = pageNumberWanted * pageSize ;
            pageNumber = pageNumberWanted;
        }
    }

    indexUtilBean.setStartIndex(""+reqStartInt);
    indexUtilBean.setEndIndex(""+reqEndInt);

    if (dsrouting != null)
        myBeans = dsrouting.getTaskBeanForOwner(user, asked, reqStartInt, reqEndInt);
    else
    {
%>
    <script language="javascript">
    <!--
        window.alert("<%= MessageDB.get("routing_contact_failed", locale) %>");
    //-->
    </script>
<%
    }
    if ((myBeans == null) || (myBeans.size() == 0))
    {
%>
    <p>&nbsp;<font class="VariableWidth9"><%= MessageDB.get("routing_no_tasks_assigned_by_me", locale) %></font><p>
    <p class="routing_wizard_copyright"><%= MessageDB.get("xerox_copyright", locale) %></p>    	
<%
        return;
    }

try{
%>
<form name="assignedByMe">
<input type="hidden" name="pageDirection" value="" />

<div class="toolbar_paging">
    <select size='1' name='pageRangeMenu' onChange='this.form.goPageButton.click()'>
      <% for(int i=1; i<=pageCount; i++) {
      %>
      <option value='<%= i %>' <%= indexUtilBean.isPageRangeMenuSelected(""+i) %> ><%=MessageDB.get("page_x_of_y", new Object[] {""+i,""+pageCount}, locale)%></option>
      <% } %>
      <option value='<%= buttonLabelShowAll %>' <%= indexUtilBean.isPageRangeMenuSelected(buttonLabelShowAll) %> ><%= buttonLabelShowAll %></option>
    </select>
      <% if(pageNumber>1) {
      %>
      <input type="image" onClick="this.form.pageDirection.value='previous';" alt='<%= uiPreviousPage %>' title='<%= uiPreviousPage %>' src="images/iconLtArrow_20x20.png" />
      <% } else { %>
      <img height="20" width="20" alt='<%= uiBlankImage %>' title='<%= uiBlankImage %>' src="images/iconLtArrow_dis.png">
      <% } %>
      <% if( (pageNumber<pageCount) && (reqEndInt!=totalTaskCount) ) {
      %>
      <input type="image" onClick="this.form.pageDirection.value='next';" alt='<%= uiNextPage %>' title='<%= uiNextPage %>' src="images/iconRtArrow_20x20.png" />
      <% } else { %>
      <img height="20" width="20" alt='<%= uiBlankImage %>' title='<%= uiBlankImage %>' src="images/iconRtArrow_dis.png">
      <% } %>

    <span style="visibility:hidden"><INPUT class="bs" type="SUBMIT" value="." border="0" name="goPageButton" /></span>
</div>

<table class="colltable">
    <col class="col_actions" />
    <col class="col_actions" />

    <tr>
        <th class="icon"></th>
        <th class="name"><%=MessageDB.get("routing_description", locale)%></th>
        <th><%=MessageDB.get("routing_status", locale)%></th>
        <th><%=MessageDB.get("routing_date", locale)%></th>
    </tr>
<%
    Date nowDate = new Date();
    Iterator iterTask = myBeans.iterator();
    int lineCountForSeparator = 0;
    while (iterTask.hasNext())
    {
        lineCountForSeparator++;
        TaskBean aBean = (TaskBean)iterTask.next();
        int routingIdInt = ((Integer)aBean.get(TaskBean.TASKID)).intValue();

      try{ //C23050+
        String routingStatus = (String)aBean.get(TaskBean.STATUS);
        routingStatus = dsrouting.getLocalizedStatus(routingStatus, locale);
        Date creationDate = (Date)aBean.get(TaskBean.TASKBYMEDATE);
        String dateStr = new SimpleDateFormat(MessageDB.get("date_short_2"+keySuffix, locale)).format(creationDate); //AR8506+
        String subject = (String)aBean.get(TaskBean.SUBJECT);

        // get action from routing slip
        // String workFlowAction = dsrouting.getWorkFlowAction(myJobs[i]);

        // use workflow action (e.g. ForReview, ForApproval) as the
        // target for the Report URL
        // build full URL string
        //AR6223-: String reportUrlStr =   workFlowAction + "Report.jsp" + "?workFlowJobName=" + myJobs[i];
        String reportUrlStr = "report_base.jsp?reportType="+ aBean.get(TaskBean.ACTION) + "Report&workFlowJobName=" + routingIdInt; //AR6223+

        // use the first document title as the subject if no subject specified
        // TODO Yet to decide whether to move the isDocumentRemoved() and getDocuments() into TaskBean, pending how we solve one of the AR which reported outdated document title
        if (subject.length() == 0)
        {
            int taskId = ((Integer)aBean.get(TaskBean.TASKID)).intValue();
        	// Singapore team AR2731 fix stack trace appears when document is deleted - BEGIN
            if(dsrouting.isDocumentRemoved(taskId))
            {
                subject = "<font color=\"red\">" + MessageDB.get("routing_error_docs_removed", locale) + "</font>";            	
        	}
        	else
        	{
                String doc = (String) dsrouting.getDocuments(taskId).iterator().next();
                DSHandle dsHandle = new DSHandle(doc);
                DSObject dsObj = dsSession.getObject(dsHandle, new DSSelectSet(DSObject.title)); //AR13400
                if (dsObj instanceof DSVersion) {
                    // get document from version
                    dsObj = ((DSVersion)dsObj).getDocument(DSSelectSet.NO_PROPERTIES);
                }
                // use the first document as the subject if no subject given
                subject = "re: " + ((DSDocument)dsObj).getTitle();
            }
            // AR2731 - END
        }
		subject = AmberUtility.xss_safe_value(subject);
%>

    <tr>
        <td><img alt='<%= uiTaskIcon %>' title='<%= uiTaskIcon %>' src="images/action_routing.gif" /></td>
        <td class="name"><a class="uline" href="javascript:openTaskWindow('<%= reportUrlStr %>')"><%= (subject.length() == 0) ? "- &nbsp;"  : subject %></a>
 <%
        Object od = aBean.get(TaskBean.DUEDATE);
        Date dueDate = (od==null) ? null : (Date)od;
        if ((dueDate != null) && !dueDate.after(nowDate))
        {
            if (aBean.isRunning())
            {
%>
                <font color='red'><b>&nbsp;(<%= MessageDB.get("routing_overdue", locale) %>)</b></font>
<%
            }
        }
%>
       </td>
        <td><%= routingStatus %></td>
        <td class="lightem"><%= dateStr %></td>
    </tr>
<%
      //C23050+:
      }catch(Exception ex)
      {
        System.out.println("#### tasks_assigned_by_me.jsp found invalid workflow " + routingIdInt + ": " + ex);
        String Subject = "", Action = "", RoutingStatus = "";

        try {
            Subject = (String)aBean.get(TaskBean.SUBJECT);
            System.out.println("  ## Subject = "+ Subject);
        }catch(Exception e) { System.out.println("  ## null Subject = "+ e);}

        try {
            Action = (String)aBean.get(TaskBean.ACTION);
            System.out.println("  ## Action = "+ Action);
        }catch(Exception e) { System.out.println("  ## null Action = "+ e);}

        try {
            RoutingStatus = (String)aBean.get(TaskBean.STATUS);
            System.out.println("  ## RoutingStatus = "+ RoutingStatus);
        }catch(Exception e) { System.out.println("  ## null RoutingStatus = "+ e);}

        try {
            System.out.println("  ## CreationTime = "+ aBean.get(TaskBean.TASKBYMEDATE));
        }catch(Exception e) { System.out.println("  ## null CreationTime = "+ e);}

        try {
            System.out.println("  ## isDocumentRemoved = "+ dsrouting.isDocumentRemoved(routingIdInt));
        }catch(Exception e) { System.out.println("  ## isDocumentRemoved = "+ e);}

        try {
            System.out.println("  ## Documents = "+ dsrouting.getDocuments(routingIdInt));
        }catch(Exception e) { System.out.println("  ## null Documents = "+ e);}

        try {
            System.out.println("  ## ByDate = "+ aBean.get(TaskBean.DUEDATE));
        }catch(Exception e) { System.out.println("  ## null ByDate = "+ e);}

        try {
            System.out.println("  ## isJobRunning = "+ aBean.isRunning());
        }catch(Exception e) { System.out.println("  ## isJobRunning = "+ e);}

        try{ //remove this invalid workflow:
            if(Action==null || Action.length()<3 || RoutingStatus==null || RoutingStatus.length()<1)
            {
                System.out.println("#### removing invalid workflow " + routingIdInt + " ...");
                dsrouting.removeWorkFlowJob(routingIdInt);
            }
        }catch(Exception e) { System.out.println("  ## cannot remove invalid workflow " + routingIdInt + ": "+ e);}

      }//end C23050+ catch
    }//while list
%>
</table>
</form>
<%
}
catch(Exception ee) {
    ee.printStackTrace();
    System.out.println("tasks_assigned_by_me.jsp: " + ee);
}
%>
<p class="routing_wizard_copyright"><%= MessageDB.get("xerox_copyright", locale) %></p>
</div>
</body>
</html>